<?php
/* -------------------------------------------------------------
This file is part of the FreeNATS SDK

FreeNATS is (C) Copyright 2008-2010 PurplePixie Systems

FreeNATS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FreeNATS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FreeNATS.  If not, see www.gnu.org/licenses

For more information see www.purplepixie.org/freenats
-------------------------------------------------------------- */

function DispElement($id,$b,$s="")
{
	echo "\n<TR><TD ALIGN=\"LEFT\"><B>".$id."</B></TD>";
	echo "<TD ALIGN=\"LEFT\">".htmlspecialchars($b)."</TD></TR>";
	echo "<TR><TD> </TD><TD ALIGN=\"LEFT\">";
	echo "<INPUT TYPE=\"TEXT\" NAME=\"LE_".$id."\" SIZE=\"96\" VALUE=\"".htmlspecialchars($s)."\">";
	echo "</TD></TR>\n";
}

function PersistFiles()
{
	global $base_file,$second_file;
	echo "<INPUT TYPE=\"HIDDEN\" NAME=\"basefile\" VALUE=\"".$base_file."\">";
	echo "<INPUT TYPE=\"HIDDEN\" NAME=\"secondfile\" VALUE=\"".$second_file."\">";
}


$base = "/opt/freenats/";
if (!isset($_REQUEST['basefile'])) $base_file = $base."server/base/lang/English.en.lang.php";
else $base_file = $_REQUEST['basefile'];
if (!isset($_REQUEST['secondfile'])) $second_file = $base."server/base/lang/Fish.fi.lang.php";
else $second_file = $_REQUEST['secondfile'];

$action="";
if (isset($_REQUEST['action']))
	{
	switch($_REQUEST['action'])
		{
		case "load": $action="load";
		break;
		case "generate": $action="generate";
		break;
		case "write": $action="write";
		break;
		default: $action="";
		}
	}

?>
<HTML><HEAD>
<TITLE>FreeNATS Language Editor 0.01</TITLE>
<STYLE TYPE="text/css">
div.hidden
	{
	display: none;
	}
</STYLE>
<SCRIPT TYPE="text/javascript">
function DisplayHide(element)
{
var item=document.getElementById(element);
if (item.style.display == "block") item.style.display = "none";
else item.style.display = "block";
}
</SCRIPT>
</HEAD>
<BODY>
<H1>Language Editor for FreeNATS 0.01 (<A HREF="http://www.purplepixie.org/freenats/wiki/Language_Editor_Tool" TARGET="top">Help for Tool</A>)</H1>
<?php
echo "<TABLE WIDTH=100% BORDER=0>";
if ($action == "") echo "<FORM ACTION=\"language-creator.php\" METHOD=\"POST\">";
echo "<TR><TD ALIGN=\"left\">";
echo "Base Language File: ";
echo "</TD><TD ALIGN=\"left\">";
if ($action == "") echo "<INPUT TYPE=\"TEXT\" NAME=\"basefile\" SIZE=\"96\" VALUE=\"".$base_file."\">";
else echo $base_file;
echo "</TD></TR>";

echo "<TR><TD ALIGN=\"left\">";
echo "Second Language File: ";
echo "</TD><TD ALIGN=\"left\">";
if ($action == "") echo "<INPUT TYPE=\"TEXT\" NAME=\"secondfile\" SIZE=\"96\" VALUE=\"".$second_file."\">";
else echo $second_file;
echo "</TD></TR>";

if ($action == "")
	{
	echo "<TR><TD> </TD><TD ALIGN=\"LEFT\">";
	echo "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"load\">";
	echo "<INPUT TYPE=\"SUBMIT\" VALUE=\"Load Language Files\">";
	echo "</TD></TR>";
	}


if ($action=="") echo "</FORM>";
echo "</TABLE>";

if ($action == "load") // load and edit mode
	{
	echo "<hr>";
	if (!file_exists($base_file))
		{
		echo "<B STYLE=\"color: red;\">Base Language File Does Not Exist</B> -- ".$base_file;
		echo "<BR /><BR />Fatal Error - <A HREF=\"language-creator.php\">Click here to restart</A>";
		exit();
		}
	echo "Loading base file... ";
	include($base_file);
	echo "Ok. Loaded ".count($lang)." elements<BR />";
	$base_lang = $lang;
	$lang=array();
	
	if (file_exists($second_file))
		{
		echo "Loading secondary file... ";
		include($second_file);
		echo "Ok. Loaded ".count($lang)." elements<BR />";
		}
	else
		{
		echo "<B STYLE=\"color: red;\">Warning: </B>Secondary File Does Not Exist - loading blank array (is this intentional?)<BR />";
		}
	echo "<hr>";
	
	echo "<FORM ACTION=\"language-creator.php\" METHOD=\"POST\">";
	PersistFiles();
	echo "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"generate\">";
	
	echo "<B>Existing Matched Elements</B> (elements existing in both base and secondary language) - ";
	echo "<A HREF=\"javascript:DisplayHide('existing_div');\">Show/Hide Items</A><BR />";
	
	echo "<DIV ID=\"existing_div\" CLASS=\"hidden\">";
	echo "<TABLE WIDTH=\"100%\" BORDER=\"0\">";
	foreach($base_lang as $key => $val)
		{
		if (isset($lang[$key])) DispElement($key,$val,$lang[$key]);
		}
	echo "</TABLE>";
	echo "</DIV>\n";
	
	echo "<hr>";
	echo "<B>Missing Elements</B> (elements in the base but missing from the secondary language)<BR />";
	echo "<TABLE WIDTH=\"100%\" BORDER=\"0\">";
	foreach($base_lang as $key => $val)
		{
		if (!isset($lang[$key])) DispElement($key,$val,"");
		}
	echo "</TABLE>";
	
	echo "<hr>";
	echo "<B>Orphan Elements</B> (elements in the secondary language not requred by the base) - ";
	echo "<A HREF=\"javascript:DisplayHide('orphan_div');\">Show/Hide Items</A><BR />";
	echo "<DIV ID=\"orphan_div\" CLASS=\"hidden\">";
	echo "<TABLE WIDTH=\"100%\" BORDER=\"0\">";
	foreach($lang as $key => $val)
		{
		if (!isset($base_lang[$key])) DispElement($key,"",$val);
		}
	echo "</TABLE>";
	echo "</DIV>\n";
	
	echo "<hr>";
	echo "<BR />";
	echo "<INPUT TYPE=\"SUBMIT\" VALUE=\"Proceed to Language Codefile Generation\"><BR /><BR />";
	echo "<A HREf=\"language-creator.php\">Give Up and Restart</A>";
	
	echo "</FORM>";
	}
	
else if ($action == "generate")
	{
	echo "<HR>Generating Code...";
	$file = "";
	$file .= "<?php\n";
	$file .= "// Autogenerated FreeNATS Language Pack File\n";
	
	foreach($_REQUEST as $key => $val)
		{
		if (substr($key,0,3) == "LE_")
			{
			//echo "Found ".$key."<BR />";
			$key = substr($key,3);
			if ($val=="") $file.="// ";
			$key=str_replace("_",".",$key);
			$file .= "\$lang['".$key."'] = \"".$val."\";\n";
			}
		}
		
	$file .= "?>\n";
	
	echo "<HR>";
	echo "<FORM ACTION=\"language-creator.php\" METHOD=\"POST\">";
	PersistFiles();
	echo "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"write\">";
	echo "<TEXTAREA ROWS=36 COLS=128 NAME=\"code\">".htmlspecialchars($file)."</TEXTAREA><BR /><BR />";
	
	echo "<hr>";
	echo "Write to: <INPUT TYPE=\"TEXT\" SIZE=\"96\" NAME=\"writefile\" VALUE=\"".$second_file."\"> ";
	echo "<INPUT TYPE=\"SUBMIT\" VALUE=\"Write File\">";
	echo "</FORM>";
	}
	
else if ($action == "write")
	{
	$file = $_REQUEST['writefile'];
	$code = $_REQUEST['code'];
	echo "<hr>Writing to file ".$file." ...";
	echo "<hr>";
	
	$fp = fopen($file,"w");
	
	if ($fp<=0)
		{
		echo "<BR />";
		echo "<B STYLE=\"color: red;\">Cannot Open File for Writing!</B><BR /><BR />";
		echo "This script cannot open the file specifid (".$file.") for writing. This may be a permission error or something else.<BR /><BR />";
		echo "Please confirm the script (probably run by httpd/apache) has write access to this file - maybe chmod 777 the file and then refresh this page and confirm to resubmit POST data.<BR /><BR />";
		echo "Alternatively click BACK on the browser and copy-and-paste the code into a text document in an editor and save it yourself.<BR />";
		exit();
		}
	else
		{
		fputs($fp,$code);
		}
	fclose($fp);
	echo "Data Written to File!";
	
	
	}

?>
